using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Net;
using System.IO;

namespace UserRegistration
{
    public class ContactRegistationServer
    {
        private DataStructures.HWInfo hardwareInfo;
        private TheApplication caller;

        public ContactRegistationServer(DataStructures.HWInfo hardwareInfo, TheApplication caller)
        {
            this.hardwareInfo = hardwareInfo;
            this.caller = caller;
        }

        public void GetRegistrationKey()
        {
            WebResponse registrationKey = null;
            String url_string = "http://localhost/Registration/Registration.aspx"
                                + "?CPU=" + System.Web.HttpUtility.UrlEncode(hardwareInfo.cpuID)
                                + "&BIOS=" + System.Web.HttpUtility.UrlEncode(hardwareInfo.biosID)
                                + "&MB=" + System.Web.HttpUtility.UrlEncode(hardwareInfo.baseID)
                                + "&DISK=" + System.Web.HttpUtility.UrlEncode(hardwareInfo.diskID)
                                + "&MAC=" + System.Web.HttpUtility.UrlEncode(hardwareInfo.macID)
                                + "&VIDEO=" + System.Web.HttpUtility.UrlEncode(hardwareInfo.videoID);
            try
            {
                WebRequest requestRegistration = WebRequest.Create(url_string);
                registrationKey = requestRegistration.GetResponse();
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show("Failed to contact server");
                return;
            }
            //register I/O stream associated with myResponse
            Stream stream = registrationKey.GetResponseStream();

            //create StreamReader that reads characters one at a time
            StreamReader reader = new StreamReader(stream);

            String s = reader.ReadToEnd();
            reader.Close();

            String key = s.Substring(0, 16);
            caller.Invoke(caller.ServerNotification,new Object[]{key});
        }
    }
}
