using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Management;
using System.Reflection;
using System.IO;
using System.Threading; 

namespace UserRegistration
{
    public delegate void Notify(DataStructures.HWInfo s);
    public delegate void NotifyServer(String registrationKey);

    public partial class TheApplication : Form
    {
        //private String hardwareSignature;
        private DataStructures.HWInfo hwInfo ;
        public Notify HardwareNotifier;
        public NotifyServer ServerNotification;

        public TheApplication()
        {
            InitializeComponent();
            HardwareNotifier = new Notify(this.HWInfoRetreived);
            ServerNotification = new NotifyServer(this.ReceivedRegistationKey);
            hwInfo = new DataStructures.HWInfo();
        }

        #region Properties

        public DataStructures.HWInfo HWInfo
        {
            get
            {
                return hwInfo;
            }
            set
            {
                this.hwInfo = value;
            }
        }

        # endregion

        private void buttonGetKey_Click(object sender, EventArgs e)
        {
            pictureBoxProgress.Visible = true;
            this.Refresh();
            Application.DoEvents();
            richTextBoxHWKeys.Text = "Retreiving Hardware Info : \n\n";
            HardwareInfo info = new HardwareInfo(this);
            Thread thread = new Thread(new ThreadStart(info.getHardWareSignature));
            thread.Start();
        }

        private void TheApplication_Load(object sender, EventArgs e)
        {
            Assembly assembly = Assembly.GetExecutingAssembly(); 

            System.IO.Stream s = assembly.GetManifestResourceStream("UserRegistration.progress.gif");
            System.IO.StreamReader sr = new StreamReader(s);

            Image img = Image.FromStream(s);
            this.pictureBoxProgress.Image = img;
            this.pictureBoxProgress2.Image = img;

            richTextBoxHWKeys.WordWrap = false;
        }

        private void HWInfoRetreived(DataStructures.HWInfo hwInfo)
        {
            this.hwInfo = hwInfo;
            //MessageBox.Show(this.HardwareSignature);
            richTextBoxHWKeys.Text = this.hwInfo.ToString();
            pictureBoxProgress.Visible = false;
            this.Refresh();
            Application.DoEvents();

            richTextBoxSerialNumber.Text = "Requesting Serial No. \n\n";
            pictureBoxProgress2.Visible = true;
            pictureBoxProgress2.Refresh();


            ContactRegistationServer contactServer = new ContactRegistationServer(this.hwInfo,this);
            Thread thread = new Thread(new ThreadStart(contactServer.GetRegistrationKey));
            thread.Start();

        }

        private void ReceivedRegistationKey(String registrationKey)
        {
            richTextBoxSerialNumber.Text = "YOUR REGISTRATION KEY : \n\n"+registrationKey;
            pictureBoxProgress2.Visible = false;
            pictureBoxProgress2.Refresh();

        }
   }
}